automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [PATCH 2/9] New test silentlex.test (Automake/Lex silent-mode).


From: Stefano Lattarini
Subject: Re: [PATCH 2/9] New test silentlex.test (Automake/Lex silent-mode).
Date: Tue, 27 Apr 2010 02:11:06 +0200
User-agent: KMail/1.12.1 (Linux/2.6.30-2-686; KDE/4.3.4; i686; ; )

Patch updated (with the test slighty extended).
From 307e75e5af537dd6e8fbeda4d000f3195d52469b Mon Sep 17 00:00:00 2001
From: Stefano Lattarini <address@hidden>
Date: Tue, 27 Apr 2010 02:01:30 +0200
Subject: [PATCH 2/9] New test silentlex.test (Automake/Lex silent-mode).

* tests/silentlex.test: New test.
* tests/Makefile.am (TESTS): Updated accordingly.
---
 ChangeLog            |    4 ++
 tests/Makefile.am    |    1 +
 tests/Makefile.in    |    1 +
 tests/silentlex.test |  142 ++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 148 insertions(+), 0 deletions(-)
 create mode 100755 tests/silentlex.test

diff --git a/ChangeLog b/ChangeLog
index b082f75..580f282 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,9 @@
 2010-04-27  Stefano Lattarini  <address@hidden>
 
+       New test `silentlex.test' (Automake silent-mode with Lex).
+       * tests/silentlex.test: New test.
+       * tests/Makefile.am (TESTS): Updated accordingly.
+
        Relax tests on silent-rules to cater for overly verbose makes.
        * tests/silent.test: When testing silent builds, don't fail if
        make's output simply contains the `mv' substring, but only if
diff --git a/tests/Makefile.am b/tests/Makefile.am
index cff34c5..c945ebe 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -624,6 +624,7 @@ silent6.test \
 silent7.test \
 silent8.test \
 silent9.test \
+silentlex.test \
 sinclude.test \
 srcsub.test \
 srcsub2.test \
diff --git a/tests/Makefile.in b/tests/Makefile.in
index 3ff9012..e93c616 100644
--- a/tests/Makefile.in
+++ b/tests/Makefile.in
@@ -865,6 +865,7 @@ silent6.test \
 silent7.test \
 silent8.test \
 silent9.test \
+silentlex.test \
 sinclude.test \
 srcsub.test \
 srcsub2.test \
diff --git a/tests/silentlex.test b/tests/silentlex.test
new file mode 100755
index 0000000..78e0c7d
--- /dev/null
+++ b/tests/silentlex.test
@@ -0,0 +1,142 @@
+#!/bin/sh
+# Copyright (C) 2010 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Check silent-rules mode for Lex.
+
+required='flex'
+. ./defs
+
+set -e
+
+mkdir sub
+
+cat >>configure.in <<'EOF'
+AM_SILENT_RULES
+AM_PROG_CC_C_O
+AC_PROG_LEX
+AC_CONFIG_FILES([sub/Makefile])
+AC_OUTPUT
+EOF
+
+cat > Makefile.am <<'EOF'
+# Need generic and non-generic rules.
+bin_PROGRAMS = foo1 foo2
+foo1_SOURCES = foo.l
+foo2_SOURCES = $(foo1_SOURCES)
+foo2_CFLAGS = $(AM_CFLAGS)
+SUBDIRS = sub
+LDADD = $(LEXLIB)
+EOF
+
+cat > sub/Makefile.am <<'EOF'
+AUTOMAKE_OPTIONS = subdir-objects
+# Need generic and non-generic rules.
+bin_PROGRAMS = bar1 bar2
+bar1_SOURCES = bar.l
+bar2_SOURCES = $(bar1_SOURCES)
+bar2_CFLAGS = $(AM_CFLAGS)
+LDADD = $(LEXLIB)
+EOF
+
+cat > foo.l <<'EOF'
+%%
+"END"   return EOF;
+.
+%%
+EOF
+cp foo.l sub/bar.l
+
+$ACLOCAL
+$AUTOMAKE --add-missing
+$AUTOCONF
+
+# configure once for fastdep, once for non-fastdep, once for nodep
+for config_args in \
+  '' \
+  am_cv_CC_dependencies_compiler_type=gcc \
+  --disable-dependency-tracking
+do
+  ./configure $config_args --enable-silent-rules
+
+  $MAKE >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  $EGREP ' (-c|-o)' stdout && Exit 1
+  $EGREP '(mv|ylwrap) ' stdout && Exit 1
+
+  grep 'LEX .*foo\.' stdout
+  grep 'LEX .*bar\.' stdout
+  grep ' CC .*foo\.' stdout
+  grep ' CC .*bar\.' stdout
+  grep 'CCLD .*foo1' stdout
+  grep 'CCLD .*bar1' stdout
+  grep 'CCLD .*foo2' stdout
+  grep 'CCLD .*bar2' stdout
+
+  # Cleaning and then rebuilding with the same V flag (and without
+  # removing the generated sources in between) shouldn't trigger a
+  # different set of rules.
+  $MAKE clean
+
+  $MAKE >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  $EGREP ' (-c|-o)' stdout && Exit 1
+  $EGREP '(mv|ylwrap) ' stdout && Exit 1
+
+  # Don't look for LEX, as probably lex hasn't been re-run.
+  grep ' CC .*foo\.' stdout
+  grep ' CC .*bar\.' stdout
+  grep 'CCLD .*foo1' stdout
+  grep 'CCLD .*bar1' stdout
+  grep 'CCLD .*foo2' stdout
+  grep 'CCLD .*bar2' stdout
+
+  # Ensure a truly clean rebuild.
+  $MAKE clean
+  rm -f foo.c sub/bar.c
+
+  $MAKE V=1 >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  grep ' -c ' stdout
+  grep ' -o ' stdout
+  grep 'ylwrap ' stdout
+
+  $EGREP '(LEX|CC|CCLD) ' stdout && Exit 1
+
+  # Cleaning and then rebuilding with the same V flag (and without
+  # removing the generated sources in between) shouldn't trigger a
+  # different set of rules.
+  $MAKE clean
+
+  $MAKE V=1 >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  # Don't look for ylwrap, as probably lex hasn't been re-run.
+  grep ' -c ' stdout
+  grep ' -o ' stdout
+
+  $EGREP '(LEX|CC|CCLD) ' stdout && Exit 1
+
+  # Ensure a truly clean reconfiguration/rebuild.
+  $MAKE clean
+  $MAKE maintainer-clean
+  rm -f foo.c sub/bar.c
+
+done
+
+:
-- 
1.6.5


reply via email to

[Prev in Thread] Current Thread [Next in Thread]